#include <Servo.h> //Servo library
#include <SoftwareSerial.h> //SoftwareSerial library
#include <DFRobotDFPlayerMini.h> //MP3 DFPlayer library
#include <SevenSegmentDisplay.h> //7-segments library

Servo servoMotor;
SevenSegmentDisplay screen(2, 3, 4, 5, 6, 7, 8, 9, true); // 7-segment pins definition

SoftwareSerial mySoftwareSerial(10, 11); // definition of the RX_pin, TX_pin
DFRobotDFPlayerMini myDFPlayer;

void setup() {
  mySoftwareSerial.begin(9600);
  Serial.begin(115200);
  if (!myDFPlayer.begin(mySoftwareSerial)) {  //Use softwareSerial to communicate with mp3.
    Serial.println(F("Unable to begin:"));
    Serial.println(F("1.Please recheck the connection!"));
    Serial.println(F("2.Please insert the SD card!"));
    while (true);
  }

  myDFPlayer.volume(30);  //Set volume value. From 0 to 30

  servoMotor.attach(13);// servo data pin
  servoMotor.write(10);// servo start position

  pinMode(12, INPUT);//buttton 
  pinMode(A0, OUTPUT);//LED
}


void loop() {

  for (int c = 48; c <= 57; c++) //counts from 48 to 57 in ASCII to display 0 to 9
  {
    screen.displayCharacter(c); // display the number in the 7-segments

    if (c == 54) // 54 is 6 in ASCII
    {
      for (int t = 1; t <= 500; t++)// used to check 500 times the button
      {

        if (digitalRead(12) == LOW) { //if button pressed
          
          myDFPlayer.play(1);  //Play the first mp3 sound
          digitalWrite(A0,HIGH); //LED turns on
          
          //Servo move's open and close a small gate to let the sweets pass
          for (int i = 10; i <= 70; i++)//open the gate one grade at a time
          {
            servoMotor.write(i);//position of the servo
          }
          delay(1000);

          for (int i = 70; i >= 10; i--)//close the gate one grade at a time returning to it's original position
          {                            
            servoMotor.write(i);//position of the servo
            delay(10);
          }
          digitalWrite(A0,LOW); //LED turns off

        } else {
          delay(1);
        }
      }
    } else {
      delay(500);// time between each number displayed in the 7-segments
    }
  }




}
